config/routes.rb
# frozen_string_literal: true

require "sidekiq/web"

Rails.application.routes.draw do
  # Administrate
  constraints CanAccessAdmin do
    namespace :admin do
      root controller: "users", action: :index
      resources :users do
        post :impersonate, on: :member
      end
      get :stop_impersonating, to: :stop_impersonating, controller: "users"
      mount Flipper::UI.app(Flipper) => "/flipper", as: "flipper"
      mount Sidekiq::Web => "/sidekiq", as: "sidekiq"
      mount LetterOpenerWeb::Engine, at: "/letter_opener", as: "letters" if Rails.env.development?
    end
  end

  mount StripeEvent::Engine, at: "/stripe/webhook"

  devise_for :users,  path: "",
                      path_names: {
                        sign_in: "sign-in",
                        sign_out: "sign-out",
                        sign_up: "sign-up"
                      },
                      controllers: {
                        registrations: "users/registrations"
                      }

  unauthenticated :user do
    devise_scope :user do
      root to: "pages#features"
    end
  end

  # Signed out (marketing) pages
  get "pricing", to: "pages#pricing"
  get "about", to: "pages#about"
  get "cancelled", to: "pages#cancelled"

  # Signed in pages
  authenticated :user do
    root to: "dashboard#show", as: "dashboard"
    get "pro", to: "pages#pro"
  end

  # Avatars
  patch "avatars", to: "avatars#update"
  delete "avatar", to: "avatars#destroy"

  # Subscription stuff
  get "billing", to: "subscriptions#show"
  get "subscribe", to: "subscriptions#new"
  patch "subscriptions", to: "subscriptions#update"
end

app/controllers/subscriptions_controller.rb
# frozen_string_literal: true

class SubscriptionsController < ApplicationController
  before_action :authenticate_user!
  skip_before_action :check_access, only: :show

  # NOTE This isn't a controller for a typical model. Subscriptions live in Stripe.

  # GET '/billing'
  def show
    redirect_to subscribe_path unless current_user.sub_active?

    @plans = Plan.active.all.select(:id, :name)
  end

  # GET '/subscribe'
  def new
    redirect_to billing_path if current_user.sub_active?
  end

  # PATCH /subscriptions
  # NOTE This handles both card updates and plan swaps
  def update
    success = if params[:plan_id].present?
      plan = Plan.active.find(params[:plan_id])
      SubscriptionService.new(current_user, plan).swap_plan!
    elsif params[:payment_method_id].present?
      current_user.processor = "stripe"
      current_user.update_card(params[:payment_method_id])
    end
    if success
      redirect_to billing_path,
        flash: { success: "Subscription updated!" }
    else
      redirect_to subscribe_path,
        flash: { error: "There was an error updating your subscription :(" }
    end
  end
end

app/views/subscriptions/_card_form.haml
= form_with url: subscriptions_path, local: true, id: "payment-form", method: :patch do |f|
  .form-group
    %label{ for: "card-element" }
      Credit or debit card
    #card-element.form-control
    -# Used to display Element errors
    #card-errors{ role: "alert" }
  .form-group
    = f.label :name_on_card
    = f.text_field :name_on_card, id: "name_on_card", placeholder: "Full name", class: "form-control"
  = f.submit "Update card", class: "btn btn-primary"

app/views/subscriptions/_plan_switch_form.haml
You are on the
%strong
  = current_user.plan.name
plan which is
= current_user.plan.cost
per
= succeed "." do
  = current_user.plan.interval
= form_with url: subscriptions_path, local: true, id: "plan_switch_form", method: :patch do
  .input-group
    = select_tag :plan_id, options_from_collection_for_select(@plans, "id", "name", current_user.plan_id), { class: "custom-select" }
    .input-group-append
      %button.btn.btn-outline-success Switch

app/views/subscriptions/new.haml
%h1 Subscribe!
.row.justify-content-md-center
  .col-md-5
    - if current_user.trial_ends_at.present? && current_user.trial_ends_at > Time.current
      %p= "Your #{@current_user.product_name} trial ends in #{distance_of_time_in_words(Time.current, current_user.trial_ends_at)}. Subscribe now and billing will begin then. Yay no interruptions!"
    %p= render "card_form"

app/views/subscriptions/show.haml
.row
  .col-md
    %h3 Payment source
    = render "card_form"
  .col-md
    %h3 Plan
    = render "plan_switch_form"